*----------------------------------------------------------------------------
*
*   Program Name: ACCIRPT.PRG       Copyright: none
*   Date Created: 02/22/93           Language: Clipper 5
*   Time Created: 11:19:13             Author: Ed Phillips
*    Description: Accident Tracking report
*----------------------------------------------------------------------------

#include 'Report.ch'

#define COMPILE(c_expr) &("{||"+c_expr+"}")

STATIC bWork, cFilter

*----------------------------
*         Author: Ed Phillips
*   Date Created: 02/22/93
*----------------------------
FUNCTION AcciRpt(cRptName)
   LOCAL cPick := ' ', lRet := .f., cColor := Setcolor(M->c_pop2)
   PRIVATE disp_name := 'T_'+ProcName()

   IF Select("Location") == 0
      USE Location INDEX LocaName, LocaCode ALIAS Location NEW
   ENDIF

   SELECT Accident

   ClearLine(0, M->c_bar)
   Popscreen(cRptName)

   cPick := Menu(cRptName)

   IF Empty(cPick)
      lRet := .f.

   ELSEIF cPick == '1'

      *----------------
      * pick a location
      *----------------
      AcciRptLoc(Accident->LocaName)
      Accident->( DbSeek( Location->LocaName ) )
      bWork := { || Accident->Locaname == Location->LocaName }
      cFilter := Trim(Location->LocaName)
      lRet := .t.

   ELSE

      *---------------
      * define a query
      *---------------
      cFilter := BldQuery('ACCIDENT')
      lRet := If( Empty(cFilter), .f., .t. )

      IF lRet
         bWork := COMPILE(cFilter)
      ENDIF

   ENDIF

   SetColor(cColor)
RETURN (lRet)

*----------------------------
*         Author: Ed Phillips
*   Date Created: 02/22/93
*----------------------------
PROCEDURE AcciHdr(page)
   MEMVAR aHdr, aRpt
   LOCAL i, cSelMsg := 'Selection Criteria: ' + cFilter

   FOR i := 1 TO Len(aHdr)
      @ Lc()+1, 0 SAY PageTran(aHdr[i], page)
   NEXT                                          && FOR i := 1 TO Len(aHdr)

   @ Lc()+2,Rpt_Centr(cSelMsg, aRpt[RPT_WID]) SAY cSelMsg
   @ Lc()+2,0 SAY 'Location                                   Date    Time  Injury Damage Signal Warrant                   Notes'
   @ Lc()+1,0 SAY '         '
*                  cccccccccccccccccccccccccccccccccccccccc mm/dd/yy hh:mm     y      y      y      y     cccccccccccccccccccccccccccccccccccccccc
*                  0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
*                            1         2         3         4         5         6         7         8         9         0         1         2
RETURN

*----------------------------
*         Author: Ed Phillips
*   Date Created: 02/22/93
*----------------------------
PROCEDURE AcciDet()

   FIELD LocaName, Date, Time, Injury, Signal, Damage, Warrant, Notes

   MEMVAR aFtr
   LOCAL ftrprnt := .f., cTmp, n, i

   WHILE ! Eof()
      IF Eval(bWork)
         IF ! Enuf_ln(Lc(), M->lines - Len(aFtr), 1)
            PageFooter()
            ftrprnt := .t.
            Rpt_Header( 1, M->output, Lc(), .t. )
         ENDIF                                      && IF ! Enuf_ln(Lc(), M->lines - Len(aFtr), 1)

         @ Lc()+1,0 SAY LocaName
         @ Lc(), 41 SAY If( !Empty(Date), Date, " ")
         @ Lc(), 50 SAY If( !Empty(Time), Tran(Time, '@R 99:99'), " " )
         @ Lc(), 60 SAY Injury PICT 'Y'
         @ Lc(), 67 SAY Damage PICT 'Y'
         @ Lc(), 74 SAY Signal PICT 'Y'
         @ Lc(), 81 SAY Warrant PICT 'Y'

         cTmp := Trim(Notes)
         n := MlCount(cTmp, 40)
         @ Lc(), 87 SAY MemoLine(cTmp, 40, 1)

         FOR i := 2 TO n
            @ Lc()+1, 87 SAY MemoLine(cTmp, 40, i)
         NEXT
         @ Lc()+1,0 SAY ''
      ENDIF                                      && IF Eval(bWork)

      SKIP
      ftrprnt := .f.

   END

RETURN

FUNCTION AcciRptLoc(cLocName)                        && popup location list
   FIELD LocaName, LocaCode
   LOCAL ret_val := .t.
   LOCAL aB := {"Name"+Space(37)+"Code",;
                {|| Locaname+Space(1)+LocaCode},;
                2, 19, 22, 76,,,, }

   LOCAL oLocList := BrowPick():new()            && create list object

   *----------------------------
   * set list instance variables
   *----------------------------
   oLocList:listcolor := M->c_pop
   oLocList:popscrn := "locpop"
   oLocList:key := cLocName
   oLocList:nWork := Select("Location")

   ret_val := oLocList:BrowList(aB)              && invoke list

RETURN(ret_val)

* EOf: AcciRpt.prg
