*.............................................................................
*
*   Program Name: DRAWLINE.PRG      Copyright: none
*   Date Created: 06/06/91           Language: Clipper 5.0
*   Time Created: 13:30:00             Author: Ed Phillips

*----------------------------------------------------------------------------
* Function: Drawline
* Purpose : Draws a line on the output device of specified length and type
* Syntax  : Drawline( <expN1>, [<expN2>] )
*              where expN1 = length of line
*                    expN2 = optional line type 
*                            (1 = single, 2 = double, 3 = hyphens)
*                            defaults to type 1
*
*           EXAMPLE: @ 10,10 SAY Drawline(25)
* Returns : string
*----------------------------------------------------------------------------

FUNCTION Drawline( length, line_type )
   PRIVATE line_char

   line_type = If( ValType(line_type) = 'U', 1, line_type )

   IF line_type = 1
      line_char = Chr(196)
   ELSEIF line_type = 2
      line_char = Chr(205)
   ELSE
      line_char = '-'
   ENDIF
RETURN ( Replicate(line_char,length) )
* EOF: DRAWLINE.PRG
