*.............................................................................
*
*   Program Name: PICKLIST.PRG      Copyright: none
*   Date Created: 07/26/91           Language: Clipper 5.0
*   Time Created: 06:33:24             Author: Ed Phillips
*           Desc: Pick 0 or 1 item from an array list
*
* Syntax: PickList(aListName, cTitle, cMenuWidth, nTop, nLeft)
*.............................................................................

FUNCTION PickList(aListName, cTitle, cMenuWidth, nTop, nLeft, nItem, nBrow)

   LOCAL brow, rc, j, selection := 0, tlen

   *-----------------------------------------------------------------------
   *   build selection list window parameters and center title
   *-----------------------------------------------------------------------
   tlen = ( cMenuWidth - Len(cTitle) ) / 2
   cTitle = Space(tlen) + cTitle + Space(tlen)
   IF Len(cTitle) % 2 != 0
      cTitle = cTitle + Space(1)
   ENDIF

   IF ValType(nBrow) == 'U'
      nBrow := 22
   ENDIF

   rc = 2 + cMenuWidth + 2 + nLeft
   brow := nTop + 4 + Len(aListName)

   IF brow > nBrow
      brow = nBrow
   ENDIF

   Scroll(nTop,nLeft,brow,rc,0)
   @ nTop, nLeft TO brow, rc DOUBLE
   @ nTop+1, nLeft + 2 SAY cTitle
   @ nTop+2, nLeft SAY ''

   @ nTop+2, nLeft+1 SAY Drawline(rc - nLeft)
   @ nTop+2, rc SAY ''

   *-----------------------------------------------------------------------
   *   pop-up selection menu and get choice
   *-----------------------------------------------------------------------

   Sayhelp('<Enter> = Select     <Esc> = Done')

   IF ValType(nItem) = 'U'
      nItem := 1
   ENDIF                                         && IF ValType(nItem) = 'U'

   selection = Achoice(nTop+4,nLeft+2,brow-1,rc-2,aListName,.t.,,nItem)
RETURN (selection)
* EOF: PICKLIST.PRG
