*----------------------------------------------------------------------------
*
*   Program Name: PUBSKEL.PRG       Copyright: none
*   Date Created: 03/27/92           Language: Clipper 5
*   Time Created: 09:08:35             Author: Ed Phillips
*    Description: Declare and Define system wide public variables
*----------------------------------------------------------------------------

PROCEDURE Pubskel(bw)

   IF ValType(bw) = 'U'
      bw := .f.
   ENDIF

   PUBLIC ex_flg := .f., ok := .t.

   PUBLIC ed_choice := 1

   *---------------------
   * Define system colors
   *---------------------
   PUBLIC c_bar, c_data, c_error, c_field, c_fielda, c_help, c_list, c_lista
   PUBLIC c_norm, c_pop, c_pop1, c_pop2, c_title, c_mag, c_yel, c_rb
   PUBLIC c_wbg, c_ybg, c_say, c_get, c_nbg

   IF Iscolor() .AND. ! bw
      c_bar    = "W/N,W+/GR"                     && bar menu
      c_data   = "W+/G,G/B,N,,W/B"               && data color
      c_error  = "W+/R,W+/G,,,W/R"               && error color
      c_field  = "W+/B,W+/R,N,,W+/R"             && field color
      c_fielda = "GR+/B,W+/G,N,,W+/B"            && alternate field color
      c_help   = "W+/G,,,,W+/G"                  && help color
      c_list   = "GR+/B,N/B,N,,W/B"              && list color
      c_lista  = "W+/B,GR+/B,N,,W+/B"            && alternate list color
      c_norm   = "W/N,W+/G,N,, W/G"              && normal color
      c_pop    = 'B/W,W+/B'                      && pop up menu
      c_pop1   = 'W/B,B/W'                       && alt pop up
      c_pop2   = 'W+/BG,B/W'                     && alt pop up
      c_title  = 'W+/B,GR+/N,N,,GR/N'            && title color
      c_mag    = 'W+/BR'
      c_yel    = 'GR+/B'
      c_rb     = 'R+/B'
      c_wbg    = 'W+/BG'
      c_ybg    = 'GR+/BG'
      c_say    = 'N/W,W+/G'
      c_get    = 'W+/R'
      c_nbg    = 'N/BG'
   ELSE
      c_bar    = 'W/N,N/W'
      c_data   = "W/N,N/W,N,,W/N"
      c_error  = "N/W,W/N,,,N/W"
      c_field  = "W/N,N/W,N,,N/W"
      c_fielda = "W/N,N/W,N,,N/W"
      c_help   = "W+/N,,,,W+/N"
      c_list   = "W/N,N/W,N,,W/N"
      c_lista  = "W/N,N/W,N,,W/N"
      c_norm   = "W+/N,N/W,N,,N/W"
      c_pop    = 'N/W,W+/N'
      c_pop1   := c_pop2 := 'W+/N,N/W'
      c_title  = "W/N,N/W,N,,N/W"
      c_mag    = "W/N"
      c_yel    = 'W/N'
      c_wbg    = 'W+/N'
      c_ybg    = 'W+/N'
      c_rb     = 'W/N'
      c_say    = 'W/N,N/W'
      c_get    = 'N/W,N/W'
      c_nbg    = 'N/W'
   ENDIF                                            && IF Iscolor() .AND. ! bw

   PUBLIC exit_msg := 'Press <PgDn> to Exit'
   PUBLIC del_msg := '** MARKED FOR DELETION **'
   PUBLIC esc_msg := 'Press <Esc> to Exit'
   PUBLIC edt_msg := '<PgDn> = Exit/Save     <Esc> = Exit/No Save'

   *---------------------------
   * Names of system Data Bases
   *---------------------------
   PUBLIC cHelpDbf := 'HELP', cScreenDbf := 'SCREEN', cDbfDbf := 'SYSDBF'
   PUBLIC cNtxDbf := 'SYSNTX', screen := cScreenDbf

   PUBLIC prn, prnstr, syspath
RETURN
* EOF: Pubskel.PRG
