*----------------------------------------------------------------------------
*
*   Program Name: QUERY1.PRG        Copyright: none
*   Date Created: 02/23/93           Language: Clipper 5
*   Time Created: 15:46:16             Author: Ed Phillips
*    Description: QBE query builder
*----------------------------------------------------------------------------

#include "Set.ch"
#include "Inkey.ch"

#define FLDNAME 1
#define FLDTYPE 2
#define FLDLEN  3
#define FLDDEC  4

STATIC cond, lFirst, cLastChr

FUNCTION BldQuery(cGroup)
   FIELD Qfilter, QGroup, Group, Query
   MEMVAR getlist, c_field, ex_flg, cQueryName, ok

   LOCAL i := 1, nSel := 1, nRow := 5, connector, working
   LOCAL savscrn, prom1, mcqnum, nCol := 38, cTit, lAdded
   LOCAL oldarea := Select(), oldcolor := Setcolor(), savewin, tmpclr
   LOCAL oldscore := Set(_SET_SCOREBOARD), oldCursor := SetCursor()

   PRIVATE xValue, aPtr := 1, mcQuery, op, disp_name := 'T_'+ProcName()
   PRIVATE flist := {}, aPicks := {}

   lFirst := .t.
   cLastChr := cond := ' '
   IF !File('Qfield.dbf')
      RETURN cond
   ENDIF

   IF Select("Qfield") == 0
      USE Qfield ALIAS Qfield NEW
   ENDIF                                         && IF Select(Qfield) == 0

   SELECT Qfield

   IF ! Empty(cGroup)
      SET FILTER TO Trim(Group) == cGroup
   ENDIF                                         && IF ! Empty(cGroup)

   GO TOP
   WHILE ! Eof()
      IF Field->Query
         aAdd(aPicks, FIELD->Field_desc)
         aAdd(flist, { FIELD->Field_name, FIELD->Field_type, FIELD->Field_len, FIELD->Field_dec})
      ENDIF                                      && IF Field->Query

      SKIP
   END

   USE

   Setcolor(c_field)
   CLEAR

   cTit = ' Create a query '
   @ 1,0 TO 23,79 DOUBLE
   @ 1,Centr(cTit) SAY cTit

   ok = .t.
   working := If(Len(aPicks) == 0, .f., .t.)
   @ 17,8 TO 22,72
   @ 17,31 SAY ' Query Definition '
   Scroll(18,9,21,71,0)

   WHILE working
      connector := xValue := ''

      *---------------------
      * Get the "field name"
      *---------------------
      nSel = PickList(aPicks, "Select a Field", 20, 3, 1, nSel, 16)
      @ 24,0 CLEAR

      IF nSel = 0
         EXIT
      ENDIF                                         && IF nSel = 0

      BEGIN SEQUENCE

         *-------------------
         * Get the "operator"
         *-------------------
         savscrn = Savescreen()
         op = OpBox(flist[nSel,FLDTYPE])

         IF Empty(op)
            ok = .f.
            working = .f.
            BREAK
         ENDIF                                      && IF Empty(op)

         *-----------------------------
         * Get the "value" of the field
         *-----------------------------
         ValInit('xValue', flist, nSel)

         tmpclr := Setcolor(M->c_pop)
         @ 7,21 TO 9,59
         Scroll(8,22,8,58,0)
         Shadow(7,21,9,59)

         Set(_SET_SCOREBOARD, .f.)

         @ 7,35 SAY ' Enter a Value '
         SetCursor(1)
         @ 8,23 GET xValue

         IF flist[nSel,FLDTYPE] = 'L'
            CLEAR GETS
         ELSE
            READ
         ENDIF
         SetCursor(oldCursor)
         Set(_SET_SCOREBOARD, oldscore)
         Setcolor(tmpclr)

         IF Empty(xValue)
            ok = .f.
            working := .f.
            BREAK
         ENDIF

         *----------------
         * Build condition
         *----------------
         cond += Condition(op, flist[nSel,FLDNAME], xValue, flist[nSel,FLDTYPE])
         Restscreen(,,,,savscrn)
         Saymemo(cond,18,10,60,4)

         *----------------------------
         * Get the logical "connector"
         *----------------------------
         connector = AndOrExit(5, 42)

         IF Upper(connector) = 'DONE'
            working = .f.
            BREAK
         ENDIF                                         && IF Upper(connector) = 'DONE'

         cond += ' '+ connector + '  '         && add connector to condition
         Saymemo(cond,18,10,60,4)
      END
   ENDDO                                            && DO WHILE .T.

   IF !Empty(cond)
      cond += cLastChr
      cond := Trim(cond)

      i := At( '.OR. (  )', cond )
      IF i > 0
         cond := Subs(cond, 1, i-1 )
      ENDIF                                      && IF i > 0

      i := At( '.AND. (  )', cond )
      IF i > 0
         cond := Subs(cond, 1, i-1 )
      ENDIF                                      && IF i > 0

      IF Right(cond, 1) == '.'
         cond := Subs(cond, 1, Len(cond)-5)
      ENDIF
   ENDIF                                         && IF !Empty(cond)

   Restscreen(,,,,savscrn)
   Saymemo(cond,18,10,60,4)

   SELECT (oldarea)
   Setcolor(oldcolor)
RETURN (cond)

*----------------------------
*         Author: Ed Phillips
*   Date Created: 02/24/93
*----------------------------
FUNCTION OpBox(cFtype)
   LOCAL ret_val := Space(3), nSel := 0, nTop := 4, nLeft := 8, lErr
   LOCAL aOpList := {}, nWinWidth := 24, aOperator := {}
   LOCAL cColor := SetColor(M->c_pop)

   DO CASE

      CASE cFtype = 'L'
         Aadd( aOpList, 'True    ' ); Aadd( aOperator, '='   )
         Aadd( aOpList, 'Not True' ); Aadd( aOperator, 'NOT' )
         nWinWidth := 18

      CASE cFtype $ 'DN'
         Aadd( aOpList, 'Equal to                ' ); Aadd( aOperator, '='  )
         Aadd( aOpList, 'Less than               ' ); Aadd( aOperator, '<'  )
         Aadd( aOpList, 'Greater than            ' ); Aadd( aOperator, '>'  )
         Aadd( aOpList, 'Less than or equal to   ' ); Aadd( aOperator, '<=' )
         Aadd( aOpList, 'Greater than or equal to' ); Aadd( aOperator, '>=' )
         Aadd( aOpList, 'Not equal to            ' ); Aadd( aOperator, '#'  )

      CASE cFtype $ 'CM'
         Aadd( aOpList, 'Equal to                ' ); Aadd( aOperator, '='  )
         Aadd( aOpList, 'Less than               ' ); Aadd( aOperator, '<'  )
         Aadd( aOpList, 'Greater than            ' ); Aadd( aOperator, '>'  )
         Aadd( aOpList, 'Less than or equal to   ' ); Aadd( aOperator, '<=' )
         Aadd( aOpList, 'Greater than or equal to' ); Aadd( aOperator, '>=' )
         Aadd( aOpList, 'Not equal to            ' ); Aadd( aOperator, '#'  )
         Aadd( aOpList, 'Contains                ' ); Aadd( aOperator, '$'  )
         Aadd( aOpList, 'Does not contain        ' ); Aadd( aOperator, '!$' )

   ENDCASE                                 && DO CASE

   nSel = Picklist(aOpList, "Select an Operator", nWinWidth, nTop, nLeft,, 18)
   IF nSel != 0
      ret_val := aOperator[nSel]
   ENDIF                                         && IF nSel != 0
   Setcolor(cColor)
RETURN (ret_val)


*----------------------------
*         Author: Ed Phillips
*   Date Created: 07/26/91
*----------------------------
FUNCTION ValInit(var,flist,nsel)
   LOCAL work, ftype, flen, fdec

   ftype := flist[nsel, FLDTYPE]
   flen := flist[nsel, FLDLEN]
   fdec := flist[nsel, FLDDEC]

   DO CASE
      CASE ftype = 'D'
         &var = CTOD([])

      CASE ftype = 'C' .OR. ftype = 'M'
         IF flen < 36 .AND. ftype != 'M'
            &var = Space(flen)
         ELSE
            &var = Space(35)
         ENDIF

      CASE ftype = 'N'
         work = Str(0, flen, fdec)       //Space(flen)
         &var = Val(work)

      CASE ftype = 'L'
         &var = If( M->op == 'NOT', 'False', 'True' )

   ENDCASE
RETURN (NIL)

*----------------------------
*         Author: Ed Phillips
*   Date Created: 07/30/91
*----------------------------
FUNCTION Condition(op, cField, cVal, cType)
   LOCAL ret_val
   PRIVATE disp_name := 'T_'+ProcName()

   DO CASE
      CASE op == '$'
         ret_val := "'" + Trim(cVal) + "'" + ' $ ' + Trim(cField)

      CASE op == '!$'
         ret_val := "!('" + Trim(cVal) + "'" + ' $ ' + Trim(cField) + ')'

      CASE cType == 'D'
         ret_val := Trim(cField) + ' ' + op + ' Ctod("' + Dtoc(cVal) + '")'

      CASE cType == 'N'
         ret_val := Trim(cField) + ' ' + op + Ltrim(Str(cVal))

      CASE cType == 'C' .OR. cType == 'M'
         ret_val := Trim(cField) + ' ' + op + ' "' + Trim(cVal) + '"'

      CASE cType == 'L'
         IF op == 'NOT'
            ret_val := '.NOT. ' + Trim(cField)
         ELSE
            ret_val := Trim(cField)
         ENDIF

      OTHERWISE
         ret_val := ' '

   ENDCASE
RETURN ( ret_val )

*----------------------------
*         Author: Ed Phillips
*   Date Created: 02/24/93
*----------------------------
FUNCTION AndOrExit(nRow, nCol, cColor)
   STATIC menuSet

   LOCAL ret_val := 'Done', item := 0, aMenuItems := {}, savscrn, oldcolor
   LOCAL nBot
   PRIVATE disp_name := 'T_'+ProcName()

   IF lFirst
      menuSet := 1
      lFirst := .f.
   ENDIF

   nBot := nRow + 5

   Aadd( aMenuItems, '.AND.' )
   Aadd( aMenuItems, '.OR.' )
   IF menuSet == 1
      Aadd( aMenuItems, '.AND. (' )
      Aadd( aMenuItems, '.OR. (' )

   ELSE
      Aadd( aMenuItems, ') .AND.' )
      Aadd( aMenuItems, ') .OR.' )

   ENDIF                                         && IF menuSet == 1

   Aadd( aMenuItems, 'Done' )

   IF ValType(cColor) = 'U'
      cColor = M->c_pop
   ENDIF                                         && IF ValType(cColor) = 'U'

   oldcolor = Setcolor(cColor)
   savscrn = Savescreen(nRow-1,nCol, nBot+1, nCol+14)
   Scroll(nRow-1,nCol, nBot, nCol+12, 0)
   @ nRow-1, nCol TO nBot, nCol+12
   Shadow(nRow-1, nCol, nBot, nCol+12)

   item := Achoice( nRow, nCol+2, nBot, nCol+10, aMenuItems, .t.)
   IF item != 0
      ret_val = aMenuItems[item]

      IF ret_val != 'Done' .AND. item > 2
         cLastChr := If( Right(ret_val, 1) == "(", ")", " " )
         menuSet++
         menuSet := If( menuSet > 2, 1, menuSet )
      ENDIF                                      && IF item == 3 .OR. item == 4

   ENDIF                                         && IF item != 0

   Setcolor(oldcolor)
   Restscreen(nRow-1, nCol, nBot+1, nCol+14, savscrn)
RETURN (ret_val)

* EOF: QUERY1.PRG
